/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.sapics.client.gui;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.sapics.client.eof.model.EOArticle;
import org.cocktail.sapics.client.eof.model.EOCatalogueArticle;
import org.cocktail.sapics.client.eof.model.EOCodeMarche;
import org.cocktail.sapics.client.eof.model.EOLotNomenclature;
import org.cocktail.sapics.client.eof.model.EOTaux;
import org.cocktail.sapics.client.swing.TableSorter;
import org.cocktail.sapics.client.swing.ZEOTable;
import org.cocktail.sapics.client.swing.ZEOTableModel;
import org.cocktail.sapics.client.swing.ZEOTableModelColumn;
import org.cocktail.sapics.client.utilities.CocktailConstantes;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class LotCodeMarcheView extends javax.swing.JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 314030464666241186L;

	protected EODisplayGroup eodCodeMarche, eodArticle;

	protected ZEOTable myEOTableCodeMarche, myEOTableArticle;
	protected ZEOTableModel myTableModelCodeMarche, myTableModelArticle ;
	protected TableSorter myTableSorterCodeMarche, myTableSorterArticle;

	/** Creates new form TemplateJPanel */
	public LotCodeMarcheView(EODisplayGroup dgCodeMarche, EODisplayGroup dgArticle) {

		eodCodeMarche = dgCodeMarche;
		eodArticle = dgArticle;

		initComponents();
		initGui();

	}


	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableCodesMarches = new javax.swing.JPanel();
        btnAddCodeMarche = new javax.swing.JButton();
        btnDelCodeMarche = new javax.swing.JButton();
        viewTableArticles = new javax.swing.JPanel();

        viewTableCodesMarches.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCodesMarches.setLayout(new java.awt.BorderLayout());

        btnAddCodeMarche.setToolTipText("Ajout d'un nouveau CN");

        btnDelCodeMarche.setToolTipText("Suppression du CN sélectionné");

        viewTableArticles.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableArticles.setLayout(new java.awt.BorderLayout());

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewTableCodesMarches, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 385, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnDelCodeMarche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, btnAddCodeMarche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(viewTableArticles, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(btnAddCodeMarche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnDelCodeMarche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(viewTableArticles, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE)
                            .add(viewTableCodesMarches, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE))
                        .add(22, 22, 22))))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddCodeMarche;
    private javax.swing.JButton btnDelCodeMarche;
    protected javax.swing.JPanel viewTableArticles;
    protected javax.swing.JPanel viewTableCodesMarches;
    // End of variables declaration//GEN-END:variables




	private void initGui() {

		btnAddCodeMarche.setIcon(CocktailConstantes.ICON_ADD);
		btnDelCodeMarche.setIcon(CocktailConstantes.ICON_DELETE);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eodCodeMarche, EOLotNomenclature.CODEMARCHE_KEY+"."+EOCodeMarche.CM_CODE_KEY, "Code", 40);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCodeMarche, EOLotNomenclature.CODEMARCHE_KEY+"."+EOCodeMarche.CM_LIB_KEY, "Libellé Code Marché", 250);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		myTableModelCodeMarche = new ZEOTableModel(eodCodeMarche, myCols);
		myTableSorterCodeMarche = new TableSorter(myTableModelCodeMarche);

		myEOTableCodeMarche = new ZEOTable(myTableSorterCodeMarche);
		//myEOTableNuits.addListener(myListenerContrat);
		myTableSorterCodeMarche.setTableHeader(myEOTableCodeMarche.getTableHeader());		

		myEOTableCodeMarche.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCodeMarche.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCodeMarche.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableCodesMarches.setLayout(new BorderLayout());
		viewTableCodesMarches.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCodesMarches.removeAll();
		viewTableCodesMarches.add(new JScrollPane(myEOTableCodeMarche), BorderLayout.CENTER);



		myCols = new Vector<ZEOTableModelColumn>();

		col = new ZEOTableModelColumn(eodArticle, EOCatalogueArticle.ARTICLE_KEY+"."+EOArticle.ART_LIBELLE_KEY, "Article", 150);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		col = new ZEOTableModelColumn(eodArticle, EOCatalogueArticle.CAAR_PRIX_HT_KEY, "Prix HT", 60);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodArticle, EOCatalogueArticle.CAAR_PRIX_TTC_KEY, "Prix TTC", 60);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodArticle, EOCatalogueArticle.TAUX_KEY+"."+EOTaux.TVA_TAUX_KEY, "Taux", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodArticle, EOCatalogueArticle.CAAR_REFERENCE_KEY, "Référence", 120);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);

		
		myTableModelArticle = new ZEOTableModel(eodArticle, myCols);
		myTableSorterArticle = new TableSorter(myTableModelArticle);

		myEOTableArticle = new ZEOTable(myTableSorterArticle);
		//myEOTableIndemnite.addListener(myListenerContrat);
		myTableSorterArticle.setTableHeader(myEOTableArticle.getTableHeader());		

		myEOTableArticle.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableArticle.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableArticle.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		viewTableArticles.setLayout(new BorderLayout());
		viewTableArticles.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableArticles.removeAll();
		viewTableArticles.add(new JScrollPane(myEOTableArticle), BorderLayout.CENTER);

	}


	public ZEOTable getMyEOTableCodeMarche() {
		return myEOTableCodeMarche;
	}


	public void setMyEOTableCodeMarche(ZEOTable myEOTableCodeMarche) {
		this.myEOTableCodeMarche = myEOTableCodeMarche;
	}


	public ZEOTable getMyEOTableArticle() {
		return myEOTableArticle;
	}


	public void setMyEOTableArticle(ZEOTable myEOTableArticle) {
		this.myEOTableArticle = myEOTableArticle;
	}


	public javax.swing.JButton getBtnAddCodeMarche() {
		return btnAddCodeMarche;
	}


	public void setBtnAddCodeMarche(javax.swing.JButton btnAddCodeMarche) {
		this.btnAddCodeMarche = btnAddCodeMarche;
	}


	public javax.swing.JButton getBtnDelCodeMarche() {
		return btnDelCodeMarche;
	}


	public void setBtnDelCodeMarche(javax.swing.JButton btnDelCodeMarche) {
		this.btnDelCodeMarche = btnDelCodeMarche;
	}




}

